2025-09-01	Dohyun Kim <nomosnomos at gmail com>

	Version 4.6

	* luatexko.lua:
	- revert the last release related to hbox: inspect the most outer
	nodes to get character code of a box in linebreak processes

	* luatexko.sty:
	- revert the last release related to pxrubrica

2025-08-27	Dohyun Kim <nomosnomos at gmail com>

	Version 4.5

	* luatexko.lua:
	- new function cjk_punctuation_spacing for classic mode
	- hbox is sort of hanja character in linebreak process.

	* luatexko.sty:
	- remove blocking glues inserted by pxrubrica

2025-08-24	Dohyun Kim <nomosnomos at gmail com>

	Version 4.4

	* luatexko.lua:
	- ignore non-glyph nodes in hbox_char_font(); so a box is now treated
	just like a character even if it starts or ends with a glue.
	- insert 0pt userkern between ruby and base boxes, to prevent possible
	glue made possible by the above change
	- insert the same userken between base character and dotemph box

2025-08-23	Dohyun Kim <nomosnomos at gmail com>

	Version 4.3

	* luatexko.lua: more fix over spacing before pxrubrica ruby

2025-08-22	Dohyun Kim <nomosnomos at gmail com>

	Version 4.2

	* luatexko.sty:
	- bsphack/esphack for punctuation-related commands

	* luatexko.lua:
	- fix a bug related to spacing between CJK punctuation and ruby

2025-07-16	Dohyun Kim <nomosnomos at gmail com>

	Version 4.1

	* luatexko.lua:
	- character widths shall be consistent with the glyph widths in the
	font program. (PDF standard document 9.2.4)
	- tagging: make sure that uline is always artifact

2025-06-14	Dohyun Kim <nomosnomos at gmail com>

	Version 4.0

	* luatexko.sty: support tagging on vertical writing

	* luatexko.lua:
	- remove redundant user whatsits
	- put dotemph box after the base characters
	- add 0xFF1A and 0xFF1B to fonts.protrusions.setups.default

2025-06-07	Dohyun Kim <nomosnomos at gmail com>

	Version 3.9

	* luatexko.lua: fix a bug related to nested \uline
	* luatexko.sty: support tagging on \ruby, \dotemph, and \uline etc

2025-02-28	Dohyun Kim <nomosnomos at gmail com>

	Version 3.8

	* luatexko.lua:
	- fix an age-old bug regarding protrusion of harfbuzz font
	- add 0xFF0C and 0xFF0E to fonts.protrusions.setups.default

2025-02-24	Dohyun Kim <nomosnomos at gmail com>

	Version 3.7

	* luatexko.sty:
	- prevent garbages in dvi mode
	- use LaTeX's build/page/before hook if available

	* luatexko.lua: change char class of some chinese chars

2023-09-11	Dohyun Kim <nomos at ktug org>

	Version 3.6

	* luatexko.lua:
	- prevent possible error in vertical writing mode
	- more precise space_skip after hangul characters

2022-11-01	Dohyun Kim <nomos at ktug org>

	Version 3.5

	* luatexko.sty:
	prevent clash with pgfpicture (use kernel's selectfont)

2022-03-20	Dohyun Kim <nomos at ktug org>

	Version 3.4

	* luatexko.sty:
	- do not delay loading of konames-utf.sty

2021-07-10	Dohyun Kim <nomos at ktug org>

	Version 3.3

	* luatexko.sty:
	- respect 'para/end' hook
	- allow linebreak before CJK Unified Ideographs Extension G

	* luatexko.lua:
	- normalize node sequence 'LV, T'
	- fix a bug wrt detection of HB fonts

2021-06-10	Dohyun Kim <nomos at ktug org>

	Version 3.2

	* luatexko.lua:
	- support automatic josa selection after hanja characters
	- dotemph/uline/ruby routines are now called from hpack_filter,
	pre_linebreak_filter, and post_linebreak_filter callbacks.

	* luatexko.sty:
	- use LaTeX's selectfont hook which require LaTeX 2021/06/01 or later
	- a new LaTeX environment: verticaltypesetting
	- new plain TeX commands: \sethangulfont \sethanjafont \setfallbackfont
	\beginverticaltypesetting \endverticaltypesetting
	- vertical/horizontal environments now honor empty argument, which means
	natural width.

2021-04-20	Dohyun Kim <nomos at ktug org>

	Version 3.1

	* luatexko.lua: insert 1/4 quad after vertical colons;
	cleverer behavior when protrusion option is given;
	process_fonts() is now called by hyphenate callback

2021-03-01	Dohyun Kim <nomos at ktug org>

	Version 3.0

	* luatexko.lua:
	do not adjust interword glue after CJK characters
	when current font is a monospaced font;
	fix a bug wrt dotemph/ruby/sout position in vertical writing.

	* luatexko.sty:
	horizontal metrics of default Hangul monospaced font are
	matched with those of Latin Modern Mono;
	deprecated command \actualtext is now removed.

2020-07-27	Dohyun Kim <nomos at ktug org>

	Version 2.9

	* luatexko.lua, luatexko.sty:
	adapt to latex-base-dev's new shipout hooks;
	adapt to luaotfload's (not yet released) new expansion feature;
	center-align horizontal writing box inside vertical writing

	* luatexko-normalize.lua:
	use lua-uni-algos package, which means that normalization
	will not be confined to Hangul characters but applied to
	all the Unicode ranges.

2020-03-20	Dohyun Kim <nomos at ktug org>

	Version 2.8

	* luatexko.lua, luatexko.sty:
	use atbegshi package for dotemph, uline, and ruby

2020-03-14	Dohyun Kim <nomos at ktug org>

	Version 2.7

	* luatexko.lua:
	use post_linebreak_filter callback;
	support expansion/protrusion in harf mode

2020-02-17	Dohyun Kim <nomos at ktug org>

	Version 2.6

	* luatexko.lua:
	discourage font substitution of monospaced ascii punctuations

	* luatexko.sty:
	use latex's newly introduced \@{rm|sf|tt|default}familyhook;
	suppress bx-font-not-found warnings and make \bfseries work again

2019-12-01	Dohyun Kim <nomos at ktug org>

	Version 2.5

	* luatexko.lua: start to support luahbtex
	* luatexko.sty: 2020 expl3 deprecation removals

2019-08-01      Dohyun Kim <nomos at ktug org>

	Version 2.4

	* luatexko.lua: allow linebreak before/after a normal hbox
	* luatexko.{sty,lua}: moveleft horizontal box inside vertical writing

2019-06-21      Dohyun Kim <nomos at ktug org>

	Version 2.3

	* luatexko.lua: prevent discretionary node after Kana;
	provide lua functions deactivateall() and reactivateall().

2019-06-07      Dohyun Kim <nomos at ktug org>

	Version 2.2

	* luatexko.sty, luatexko.lua: provide font option `InterCharStretch'

2019-05-25      Dohyun Kim <nomos at ktug org>

	Version 2.1

	* luatexko.sty: give smallest stretch to quite short ruby;
	allow star option to markoverwith.


2019-05-01      Dohyun Kim <nomos at ktug org>

	Version 2.0

	* luatexko-core.sty: removed.
	* luatexko.lua: totally rewritten.
	* luatexko.sty: Package option `nofontspec' removed.
	Font options `CompressPunctuations' `RemoveClassicSpaces'
	and `InterCharacter' added.
	`\registerbreakablebefore' and `\registerbreakableafter' added.

2019-04-06      Dohyun Kim <nomos at ktug org>

	Version 1.24

	* luatexko.lua: fix a bug regarding vertical typesetting

2019-03-24      Dohyun Kim <nomos at ktug org>

	Version 1.23

	* luatexko.lua: change post-linebreak callback from
	'post_linebreak_filter' to 'hpack_filter' with groupcode restriction.
	* luatex-core.sty: remove '\pdffontsize' and replace it with a
	more suitable equivalent.

2018-11-09      Dohyun Kim <nomos at ktug org>

	Version 1.22

	* luatexko-core.sty, luatexko.lua: new command \hangulbyhangulfont.
	This being declared, Hangul characters will be forcibly typeset
	with Hangul font even when Latin font has Hangul glyphs.

2018-08-02      Dohyun Kim <nomos at ktug org>

	Version 1.21

	* luatexko.sty: adapt to the fontspec v2.6h
	* luatexko.lua: font substitution for disc node as well

2018-04-19      Dohyun Kim <nomos at ktug org>

	Version 1.20

	* luatexko.lua: node.tail -> node.slide: see the bug reported at
	http://www.ktug.org/xe/index.php?document_srl=229431

2018-04-06      Dohyun Kim <nomos at ktug org>

	Version 1.19

	* luatexko.sty: use glueexpr

2017-09-29      Dohyun Kim <nomos at ktug org>

	Version 1.18

	* luatexko.sty: zf@enc -> f@encoding

2017-05-01      Dohyun Kim <nomos at ktug org>

	Version 1.17

	* luatexko.lua: rewrite reorderTM (reorder-tone-marks) function


2017-02-06      Dohyun Kim <nomos at ktug org>

	Version 1.16

	* luatexko.sty: patch {rm|sf|tt}family of fontspec 2017

2016-05-14      Dohyun Kim <nomos at ktug org>

	Version 1.15

	* luatexko-core.sty: allow nested underline emphasis

2016-05-08      Dohyun Kim <nomos at ktug org>

	Version 1.14

	* luatexko.lua, luatexko-core.sty: more updates for luatex 0.95,
	user_defined whatsit intead of special whatsit

2016-04-25      Dohyun Kim <nomos at ktug org>

	Version 1.13

	* luatexko.lua: direct access to vmtx table; drop caching

2016-04-22      Dohyun Kim <nomos at ktug org>

	Version 1.12

	* *.sty, *.lua: drop loading luatexbase.sty; updates for luatex 0.95
	* luatexko.lua: avoid nested underline emphasis

2015-12-10      Dohyun Kim <nomos at ktug org>

	Version 1.11

	* luatexko-core.sty: adapt to luaotfload v2.6
	* luatexko-normalize.lua: a small fix for windows os

2015-10-02      Dohyun Kim <nomos at ktug org>

	Version 1.10

	* luatexko.lua: adapt to latex 2015/10/01 and luatexbase v1.0
	* luatexko.lua: assing pre/post penalty to U+FF62, U+FF63
	* luatexko.lua: fix an infinite loop in reorderTM

2015-07-02      Dohyun Kim <nomos at ktug org>

	Version 1.9

	* luatexko.lua: some more compatibility with synctex
	* luatexko-core.sty: new environment `horizontal'
	* luatexko.lua: remove support for ideographic variations (fontloader
	supports them)

2015-05-10      Dohyun Kim <nomos at ktug org>

	Version 1.8

	* luatexko.lua: internal changes using `node.direct'
	* luatexko-core.sty: \xxruby is a convenient variant of \ruby

2015-01-16      Dohyun Kim <nomos at ktug org>

	Version 1.7

	* luatexko.sty: package option [unfonts] is removed
	* *.lua, *.sty: minor fixes and updated copyright year

2014-06-17      Dohyun Kim <nomos at ktug org>

	Version 1.6

	* luatexko.sty, luatexko.lua: new font option [NoEmbedding] prevents
	inclusion of fonts into PDF file.
	* luatexko-uhc2utf8.lua: fix a bug in utf-8 detection routine,
	reported by Karnes Kim
	* luatexko.lua: put underline leader node before text, so that text
	should not be overprinted by a color box. Requested by Karnes Kim
	* luatexko.sty: [Ligatures=TeX] is now default option for main/sans
	hangul/hanja/fallback fonts. Requires fontspec v2.4

2014-05-11      Dohyun Kim <nomos at ktug org>

	Version 1.5

	* luatexko.sty: new package option [nofontspec] which prevents loading
	of fontspec.sty
	* luatexko.lua, luatexko.sty: use Nanum Type1 fonts as final fallback
	fonts
	* luatexko.sty: font option YetHangul=Off has gone now, only YetHangul
	is still there.
	* luatexko.lua: implemented experimental support for vertical
	typesetting. LuaTeX version 0.79 or later is required.
	* luatexko.lua, luatexko-core.sty: new macro \actualtext inspired by
	accsupp.sty authored by Heiko Oberdiek.
	* luatexko.lua: italic correction for replacing cjk fonts as well

2014-01-16      Dohyun Kim <nomos at ktug org>

	Version 1.4

	* luatexko.lua: italic correction of fakeslant font
	* luatexko.sty: use everysel.sty to redefine selectfont. This fixes
	a bug reported by Hoze Yi & Juho Lee.

2013-12-06      Dohyun Kim <nomos at ktug org>

	Version 1.3

	* luatexko.lua: if \josaignoreparens=1, then characters inside
	parentheses are ignored during automatic josa selection routine.
	* luatexko.sty, luatexko-core.sty, luatexko.lua: new macros
	\hangulpunctuations \registerpunctuations etc; removed [QuoteRaise]
	font option.
	* luatexko.sty, luatexko-core.sty, luatexko.lua: new macros
	\setmainfallbackfont \setsansfallbackfont etc.

2013-07-03      Dohyun Kim <nomos at ktug org>

	Version 1.2

	* luatexko.sty: move Hangul caption setting to AtBeginDocument
	* luatexko.lua: implemented reordering of hangul tone marks;
	fix a bug wrt. \dotemph of old hangul.
	* luatexko-core.sty: adapt to \fontname fix by luaotfload

2013-05-19      Dohyun Kim <nomos at ktug org>

	Version 1.1

	* luatexko.sty: fix a bug regarding hyperref pdf string
	* luatexko.lua, luatexko-core.sty: remove redundant code wrt.
	font switching

2013-05-10      Dohyun Kim <nomos at ktug org>

	Initial release. Version 1.0

